Loading...
Searching...
No Matches
disarray< T, distributed, A >

## Detailed Description

template<class T, class A>
class rheolef::disarray< T, distributed, A >

Definition at line 641 of file disarray.h.

Inheritance diagram for disarray< T, distributed, A >:

## Public Types

typedef disarray_rep< T, distributed, A > | rep
typedef smart_pointer< rep > | base
typedef distributed | memory_type
typedef rep::size_type | size_type
typedef rep::difference_type | difference_type
typedef rep::value_type | value_type
typedef rep::reference | reference
typedef rep::dis_reference | dis_reference
typedef rep::iterator | iterator
typedef rep::const_reference | const_reference
typedef rep::const_iterator | const_iterator
typedef rep::scatter_map_type | scatter_map_type
Public Types inherited from smart_pointer< disarray_rep< T, distributed, A > >
typedef T | handled_type
typedef base::internal | internal

## Public Member Functions

| disarray (const distributor &ownership=distributor(), const T &init_val=T(), const A &alloc=A())
void | resize (const distributor &ownership=distributor(), const T &init_val=T())
A | get_allocator () const
size_type | size () const
size_type | dis_size () const
const distributor & | ownership () const
const communicator & | comm () const
reference | operator[] (size_type i)
const_reference | operator[] (size_type i) const
reference | operator() (size_type i)
const_reference | operator() (size_type i) const
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
template<class Set, class Map>
void | append_dis_entry (const Set &ext_idx_set, Map &ext_idx_map) const
template<class Set, class Map>
void | get_dis_entry (const Set &ext_idx_set, Map &ext_idx_map) const
template<class Set>
void | append_dis_indexes (const Set &ext_idx_set) const
void | reset_dis_indexes () const
void | get_dis_indexes (std::set< size_type > &ext_idx_set) const
template<class Set>
void | set_dis_indexes (const Set &ext_idx_set) const
const T & | dis_at (size_type dis_i) const
const scatter_map_type & | get_dis_map_entries () const
dis_reference | dis_entry (size_type dis_i)
template<class SetOp = typename details::default_set_op_traits<T>::type>
void | dis_entry_assembly_begin (SetOp my_set_op=SetOp())
template<class SetOp = typename details::default_set_op_traits<T>::type>
void | dis_entry_assembly_end (SetOp my_set_op=SetOp())
template<class SetOp = typename details::default_set_op_traits<T>::type>
void | dis_entry_assembly (SetOp my_set_op=SetOp())
void | dis_entry_assembly_begin ()
void | dis_entry_assembly_end ()
void | dis_entry_assembly ()
template<class RepSize>
void | repartition (const RepSize &partition, disarray< T, distributed > &new_disarray, RepSize &old_numbering, RepSize &new_numbering) const
template<class RepSize>
void | permutation_apply (const RepSize &new_numbering, disarray< T, distributed, A > &new_disarray) const
void | reverse_permutation (disarray< size_type, distributed, A > &inew2dis_iold) const
odiststream & | put_values (odiststream &ops) const
idiststream & | get_values (idiststream &ips)
void | dump (std::string name) const
template<class GetFunction>
idiststream & | get_values (idiststream &ips, GetFunction get_element)
template<class PutFunction>
odiststream & | put_values (odiststream &ops, PutFunction put_element) const
template<class PutFunction, class A2>
odiststream & | permuted_put_values (odiststream &ops, const disarray< size_type, distributed, A2 > &perm, PutFunction put_element) const
Public Member Functions inherited from smart_pointer< disarray_rep< T, distributed, A > >
| smart_pointer (T *p=0)
smart_pointer< T > & | operator= (const smart_pointer< T > &x)
| ~smart_pointer ()
Public Member Functions inherited from smart_pointer_base< T, details::constructor_copy< T > >
| smart_pointer_base (T *p=0)
smart_pointer_base< T, details::constructor_copy< T > > & | operator= (const smart_pointer_base< T, details::constructor_copy< T > > &)
| ~smart_pointer_base ()
const T * | pointer () const
const T & | data () const
const T * | operator-> () const
const T & | operator* () const
int | reference_counter () const
counter * | get_count () const

## Member Typedef Documentation

## rep

template<class T, class A>

typedef disarray_rep<T,distributed,A> rep

Definition at line 646 of file disarray.h.

## base

template<class T, class A>

typedef smart_pointer<rep> base

Definition at line 647 of file disarray.h.

## memory_type

template<class T, class A>

typedef distributed memory_type

Definition at line 649 of file disarray.h.

## size_type

template<class T, class A>

typedef rep::size_type size_type

Definition at line 650 of file disarray.h.

## difference_type

template<class T, class A>

typedef rep::difference_type difference_type

Definition at line 651 of file disarray.h.

## value_type

template<class T, class A>

typedef rep::value_type value_type

Definition at line 652 of file disarray.h.

## reference

template<class T, class A>

typedef rep::reference reference

Definition at line 653 of file disarray.h.

## dis_reference

template<class T, class A>

typedef rep::dis_reference dis_reference

Definition at line 654 of file disarray.h.

## iterator

template<class T, class A>

typedef rep::iterator iterator

Definition at line 655 of file disarray.h.

## const_reference

template<class T, class A>

typedef rep::const_reference const_reference

Definition at line 656 of file disarray.h.

## const_iterator

template<class T, class A>

typedef rep::const_iterator const_iterator

Definition at line 657 of file disarray.h.

## scatter_map_type

template<class T, class A>

typedef rep::scatter_map_type scatter_map_type

Definition at line 658 of file disarray.h.

## Constructor & Destructor Documentation

## disarray()

template<class T, class A>

disarray | ( | const distributor & | ownership = distributor(),
|  | const T & | init_val = T(),
|  | const A & | alloc = A() )

Definition at line 756 of file disarray.h.

## Member Function Documentation

## resize()

template<class T, class A>

void resize | ( | const distributor & | ownership = distributor(),
|  | const T & | init_val = T() )

Definition at line 766 of file disarray.h.

## get_allocator()

template<class T, class A>

A get_allocator | ( |  | ) | const

Definition at line 667 of file disarray.h.

## size()

template<class T, class A>

size_type size | ( |  | ) | const

Definition at line 668 of file disarray.h.

## dis_size()

template<class T, class A>

size_type dis_size | ( |  | ) | const

Definition at line 669 of file disarray.h.

## ownership()

template<class T, class A>

const distributor & ownership | ( |  | ) | const

Definition at line 670 of file disarray.h.

## comm()

template<class T, class A>

const communicator & comm | ( |  | ) | const

Definition at line 671 of file disarray.h.

## operator[]() [1/2]

template<class T, class A>

reference operator[] | ( | size_type | i | ) |

Definition at line 673 of file disarray.h.

## operator[]() [2/2]

template<class T, class A>

const_reference operator[] | ( | size_type | i | ) | const

Definition at line 674 of file disarray.h.

## operator()() [1/2]

template<class T, class A>

reference operator() | ( | size_type | i | ) |

Definition at line 675 of file disarray.h.

## operator()() [2/2]

template<class T, class A>

const_reference operator() | ( | size_type | i | ) | const

Definition at line 676 of file disarray.h.

## begin() [1/2]

template<class T, class A>

iterator begin | ( |  | ) |

Definition at line 678 of file disarray.h.

## begin() [2/2]

template<class T, class A>

const_iterator begin | ( |  | ) | const

Definition at line 679 of file disarray.h.

## end() [1/2]

template<class T, class A>

iterator end | ( |  | ) |

Definition at line 680 of file disarray.h.

## end() [2/2]

template<class T, class A>

const_iterator end | ( |  | ) | const

Definition at line 681 of file disarray.h.

## append_dis_entry()

template<class T, class A>
template<class Set, class Map>

void append_dis_entry | ( | const Set & | ext_idx_set,
|  | Map & | ext_idx_map ) const

Definition at line 686 of file disarray.h.

## get_dis_entry()

template<class T, class A>
template<class Set, class Map>

void get_dis_entry | ( | const Set & | ext_idx_set,
|  | Map & | ext_idx_map ) const

Definition at line 689 of file disarray.h.

## append_dis_indexes()

template<class T, class A>
template<class Set>

void append_dis_indexes | ( | const Set & | ext_idx_set | ) | const

Definition at line 692 of file disarray.h.

## reset_dis_indexes()

template<class T, class A>

void reset_dis_indexes | ( |  | ) | const

Definition at line 693 of file disarray.h.

## get_dis_indexes()

template<class T, class A>

void get_dis_indexes | ( | std::set< size_type > & | ext_idx_set | ) | const

Definition at line 694 of file disarray.h.

## set_dis_indexes()

template<class T, class A>
template<class Set>

void set_dis_indexes | ( | const Set & | ext_idx_set | ) | const

Definition at line 697 of file disarray.h.

## dis_at()

template<class T, class A>

const T & dis_at | ( | size_type | dis_i | ) | const

Definition at line 699 of file disarray.h.

## get_dis_map_entries()

template<class T, class A>

const scatter_map_type & get_dis_map_entries | ( |  | ) | const

Definition at line 702 of file disarray.h.

## dis_entry()

template<class T, class A>

dis_reference dis_entry | ( | size_type | dis_i | ) |

Definition at line 706 of file disarray.h.

## dis_entry_assembly_begin() [1/2]

template<class T, class A>
template<class SetOp = typename details::default_set_op_traits<T>::type>

void dis_entry_assembly_begin | ( | SetOp | my_set_op = SetOp() | ) |

Definition at line 709 of file disarray.h.

## dis_entry_assembly_end() [1/2]

template<class T, class A>
template<class SetOp = typename details::default_set_op_traits<T>::type>

void dis_entry_assembly_end | ( | SetOp | my_set_op = SetOp() | ) |

Definition at line 711 of file disarray.h.

## dis_entry_assembly() [1/2]

template<class T, class A>
template<class SetOp = typename details::default_set_op_traits<T>::type>

void dis_entry_assembly | ( | SetOp | my_set_op = SetOp() | ) |

Definition at line 713 of file disarray.h.

## dis_entry_assembly_begin() [2/2]

template<class T, class A>

void dis_entry_assembly_begin | ( |  | ) |

Definition at line 715 of file disarray.h.

## dis_entry_assembly_end() [2/2]

template<class T, class A>

void dis_entry_assembly_end | ( |  | ) |

Definition at line 716 of file disarray.h.

## dis_entry_assembly() [2/2]

template<class T, class A>

void dis_entry_assembly | ( |  | ) |

Definition at line 717 of file disarray.h.

## repartition()

template<class T, class A>
template<class RepSize>

void repartition | ( | const RepSize & | partition,
|  | disarray< T, distributed > & | new_disarray,
|  | RepSize & | old_numbering,
|  | RepSize & | new_numbering ) const

Definition at line 722 of file disarray.h.

## permutation_apply()

template<class T, class A>
template<class RepSize>

void permutation_apply | ( | const RepSize & | new_numbering,
|  | disarray< T, distributed, A > & | new_disarray ) const

Definition at line 730 of file disarray.h.

## reverse_permutation()

template<class T, class A>

void reverse_permutation | ( | disarray< size_type, distributed, A > & | inew2dis_iold | ) | const

Definition at line 735 of file disarray.h.

## put_values() [1/2]

template<class T, class A>

odiststream & put_values | ( | odiststream & | ops | ) | const

Definition at line 741 of file disarray.h.

## get_values() [1/2]

template<class T, class A>

idiststream & get_values | ( | idiststream & | ips | ) |

Definition at line 742 of file disarray.h.

## dump()

template<class T, class A>

void dump | ( | std::string | name | ) | const

Definition at line 743 of file disarray.h.

## get_values() [2/2]

template<class T, class A>
template<class GetFunction>

idiststream & get_values | ( | idiststream & | ips,
|  | GetFunction | get_element )

Definition at line 746 of file disarray.h.

## put_values() [2/2]

template<class T, class A>
template<class PutFunction>

odiststream & put_values | ( | odiststream & | ops,
|  | PutFunction | put_element ) const

Definition at line 748 of file disarray.h.

## permuted_put_values()

template<class T, class A>
template<class PutFunction, class A2>

odiststream & permuted_put_values | ( | odiststream & | ops,
|  | const disarray< size_type, distributed, A2 > & | perm,
|  | PutFunction | put_element ) const

Definition at line 749 of file disarray.h.

The documentation for this class was generated from the following file:

- /build/rheolef-L67pNR/rheolef-7.2/linalg/lib/disarray.h